unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin, ExtCtrls, ComCtrls, perlins, ExtDlgs, Grids, numerics,
  ColorGrd;

type
  MColor    = packed Record
    b, g, r : Byte;
  end;
  TLayer     = record
    FileName : String;
    Octave   : Integer;
    OrgOctave: Integer;
  end;
  TMainForm = class(TForm)
    Button1: TButton;
    Image1: TImage;
    Button2: TButton;
    SpinEditSeed: TSpinEdit;
    Label1: TLabel;
    Label2: TLabel;
    TrackBarEnd: TTrackBar;
    TrackBarStart: TTrackBar;
    Resolution: TLabel;
    TrackBarSeed: TTrackBar;
    Label3: TLabel;
    ComboBoxResize: TComboBox;
    Label4: TLabel;
    CheckBoxSmooth: TCheckBox;
    Smooth: TLabel;
    TrackBarPersistance: TTrackBar;
    Persistance: TLabel;
    Start: TLabel;
    Ende: TLabel;
    ComboBoxAdd: TComboBox;
    Label5: TLabel;
    LabelFunc1: TLabel;
    ComboBoxFunc1: TComboBox;
    Button3: TButton;
    SavePictureDialog1: TSavePictureDialog;
    time: TLabel;
    TabControl1: TTabControl;
    PanelBasic: TPanel;
    PanelPalette: TPanel;
    PanelSmooth: TPanel;
    PanelLayer: TPanel;
    StringGridSmooth: TStringGrid;
    Label7: TLabel;
    EditScale: TEdit;
    Label8: TLabel;
    Edit1Arg1: TEdit;
    Edit1Arg2: TEdit;
    Arg11: TLabel;
    Arg12: TLabel;
    Arg13: TLabel;
    Edit1Arg3: TEdit;
    PanelFunctions: TPanel;
    Edit2Arg3: TEdit;
    Edit2Arg2: TEdit;
    Edit2Arg1: TEdit;
    ComboBoxFunc2: TComboBox;
    LabelFunc2: TLabel;
    Arg21: TLabel;
    Arg22: TLabel;
    Arg23: TLabel;
    Edit3Arg3: TEdit;
    Edit3Arg2: TEdit;
    Edit3Arg1: TEdit;
    ComboBoxFunc3: TComboBox;
    LabelFunc3: TLabel;
    Arg31: TLabel;
    Arg32: TLabel;
    Arg33: TLabel;
    Edit4Arg3: TEdit;
    Edit4Arg2: TEdit;
    Edit4Arg1: TEdit;
    ComboBoxFunc4: TComboBox;
    LabelFunc4: TLabel;
    Arg41: TLabel;
    Arg42: TLabel;
    Arg43: TLabel;
    Edit5Arg3: TEdit;
    Edit5Arg2: TEdit;
    Edit5Arg1: TEdit;
    ComboBoxFunc5: TComboBox;
    LabelFunc5: TLabel;
    Arg51: TLabel;
    Arg52: TLabel;
    Arg53: TLabel;
    Edit6Arg3: TEdit;
    Edit6Arg2: TEdit;
    Edit6Arg1: TEdit;
    ComboBoxFunc6: TComboBox;
    LabelFunc6: TLabel;
    Arg61: TLabel;
    Arg62: TLabel;
    Arg63: TLabel;
    ImagePal: TImage;
    ColorDialog1: TColorDialog;
    ButtonSPal: TButton;
    ButtonLPal: TButton;
    ButtonRPal: TButton;
    SaveDialogPalette: TSaveDialog;
    OpenDialogPalette: TOpenDialog;
    CheckBoxLayer: TCheckBox;
    ComboBoxLayer1: TComboBox;
    LabelLayer1: TLabel;
    OpenDialogLayer: TOpenDialog;
    ComboBoxLayer2: TComboBox;
    Label9: TLabel;
    Label10: TLabel;
    LabelLayer2: TLabel;
    ComboBoxLayer3: TComboBox;
    LabelLayer3: TLabel;
    ComboBoxLayer4: TComboBox;
    LabelLayer4: TLabel;
    EditTrans: TEdit;
    procedure Button2Click(Sender: TObject);
    procedure TrackBarStartChange(Sender: TObject);
    procedure TrackBarEndChange(Sender: TObject);
    procedure TrackBarSeedChange(Sender: TObject);
    procedure SpinEditSeedChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CheckBoxSmoothClick(Sender: TObject);
    procedure TrackBarPersistanceChange(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure TabControl1Change(Sender: TObject);
    procedure StringGridSmoothDblClick(Sender: TObject);
    procedure StringGridSmoothKeyPress(Sender: TObject; var Key: Char);
    procedure EditScaleChange(Sender: TObject);
    procedure ComboBoxFuncChange(Sender: TObject);
    procedure EditArgChange(Sender: TObject);
    procedure ImagePalClick(Sender: TObject);
    procedure ImagePalMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ButtonRPalClick(Sender: TObject);
    procedure ButtonSPalClick(Sender: TObject);
    procedure ButtonLPalClick(Sender: TObject);
    procedure LabelLayerClick(Sender: TObject);
    procedure ComboBoxLayerChange(Sender: TObject);
    procedure CheckBoxLayerClick(Sender: TObject);
    procedure EditTransChange(Sender: TObject);
  private
    { Private-Deklarationen }
  public
  Procedure getBmps(var Bmps : Array of TBitmap; var Octaves : Array of Integer);
  Function GetFunctions(var PerlinFunc : Array of TPerlFunc) : integer;
  procedure initializePalette;
Procedure UpdateImagePal;
   { Function PerlinNoiseBmp(Persistance     : Single  ; StartOctave, Octaves : Byte;
                            Seed            : Integer ; ResizeMethod         : TResizeMethod = RMCosinus;
                            Smooth          : Boolean = False;
                            Smooth_Weighten : Single  = 1)                   : TBitmap;
 }   { Public-Deklarationen }
  end;
const PalMagic = 'Pal_1.0';
var
  MainForm       : TMainForm;
  PerlinBmp   : Tbitmap;
  Progress    : Double;
  startq, stopq,
  freqq       : Int64;
  Palette     : Array[0..255] of Cardinal;
  PalMouse    : TPoint;
  LoadedLayers: Array[0..3] of TLayer;
  CodeList    : Array[1..6] of String;
 // BmpPalette: HPalette;
implementation
uses perlFormula;
{$R *.dfm}
Function RGBtoBGR (Color    : Cardinal) : Cardinal;
Begin
  Result := ((Color and $FF) shl 16) +
            ((Color and $FF00FF00))  +
            ((Color and $FF0000) shr 16);
End;
procedure TMainForm.Button2Click(Sender: TObject);
begin
  close;
end;

procedure TMainForm.TrackBarStartChange(Sender: TObject);
var
  i, n : integer;
  cBox : TComboBox;
begin
  If TrackBarEnd.Position <  TrackBarStart.Position then
     TrackBarEnd.Position := TrackBarStart.Position;

  Start.Caption := InttoStr(TrackBarStart.Position);

  For i := 1 to 4 do
  Begin
    CBox := (FindComponent(format('ComboBoxLayer%d', [i])) as TComboBox);
    CBox.Items.Clear;
    CBox.Items.Add('None');
    For n :=  TrackBarStart.Position to TrackBarEnd.Position do
      CBox.Items.Add(inttostr(n));
    If LoadedLayers[i - 1].OrgOctave = -1 then
    Begin
      CBox.ItemIndex         := 0;
      LoadedLayers[i - 1].Octave := -1;
    end
    else
    If LoadedLayers[i - 1].OrgOctave < TrackBarStart.Position then
    Begin
      CBox.ItemIndex         := 1;
      LoadedLayers[i - 1].Octave := TrackBarStart.Position;
    end
    else
    If LoadedLayers[i - 1].OrgOctave > TrackBarEnd.Position then
    Begin
      CBox.ItemIndex         := CBox.Items.Count - 1;
      LoadedLayers[i - 1].Octave := TrackBarEnd.Position;
    end
    else
    Begin
      CBox.ItemIndex := LoadedLayers[i - 1].OrgOctave - TrackBarStart.Position + 1;
      LoadedLayers[i - 1].Octave := LoadedLayers[i - 1].OrgOctave;
    end;
  end;
end;

procedure TMainForm.TrackBarEndChange(Sender: TObject);
var
  i, n : integer;
  cBox : TComboBox;
begin
  If TrackBarStart.Position >  TrackBarEnd.Position then
     TrackBarStart.Position := TrackBarEnd.Position;

  Ende.Caption   := InttoStr(TrackBarEnd.Position);
  Resolution.caption  := format('Resolution: %d * %0:d', [1 shl (TrackBarEnd.Position + 1)]);

  For i := 1 to 4 do
  Begin
    CBox := (FindComponent(format('ComboBoxLayer%d', [i])) as TComboBox);
    CBox.Items.Clear;
    CBox.Items.Add('None');
    For n :=  TrackBarStart.Position to TrackBarEnd.Position do
      CBox.Items.Add(inttostr(n));
    If LoadedLayers[i - 1].OrgOctave = -1 then
    Begin
      CBox.ItemIndex         := 0;
      LoadedLayers[i - 1].Octave := -1;
    end
    else
    If LoadedLayers[i - 1].OrgOctave < TrackBarStart.Position then
    Begin
      CBox.ItemIndex         := 1;
      LoadedLayers[i - 1].Octave := TrackBarStart.Position;
    end
    else
    If LoadedLayers[i - 1].OrgOctave > TrackBarEnd.Position then
    Begin
      CBox.ItemIndex         := CBox.Items.Count - 1;
      LoadedLayers[i - 1].Octave := TrackBarEnd.Position;
    end
    else
    Begin
      CBox.ItemIndex := LoadedLayers[i - 1].OrgOctave - TrackBarStart.Position + 1;
      LoadedLayers[i - 1].Octave := LoadedLayers[i - 1].OrgOctave;
    end;
  end;
end;




procedure TMainForm.TrackBarSeedChange(Sender: TObject);
begin
  SpineditSeed.Value := TrackBarSeed.Position;
end;

procedure TMainForm.SpinEditSeedChange(Sender: TObject);
var
  Seed : int64;
begin
  If SpineditSeed.Text <> '' then
  Begin
    Seed := strtoInt64(SpinEditSeed.Text);
    If Seed                > SpinEditSeed.MaxValue then
       SpineditSeed.Value := SpinEditSeed.MaxValue ;
    TrackBarSeed.Position := SpineditSeed.Value;
  end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
  x, y : Integer;
//  s : string;
begin
  for x := 0 to high(CodeList) do
    CodeList[x] := 'a';

  randomize;
  Application.ProcessMessages;
  TrackBarSeed.Position := random(2147483647);  //112833683
  PerlinBmp := TBitmap.Create;
{  s := Form1.caption;
  delete(s, Length(s), 1);
  Form1.caption := s; }
  For x := 0 to 4 do
    For y := 0 to 4 do
      StringgridSmooth.cells[x, y] := '0';
  StringgridSmooth.cells[2, 2] := '1';

  For x := 0 to 3 do
  Begin
    LoadedLayers[x].FileName := '';
    LoadedLayers[x].Octave   := -1;
    LoadedLayers[x].OrgOctave:= -1;
  end;
  For x := 1 to 6 do
  Begin
    (FindComponent(Format('ComboboxFunc%d', [x])) as TComboBox).ItemIndex := 0;
  end;

  CheckBoxLayerClick(CheckBoxLayer);
  TrackBarStartChange(TrackBarStart);
  TrackBarEndChange(TrackBarEnd);
  TabControl1Change(TabControl1);
{  PanelBasic.Visible    := TabControl1.TabIndex = 0;
  PanelPalette.Visible  := TabControl1.TabIndex = 4;
  PanelSmooth.Visible   := TabControl1.TabIndex = 2;
  PanelLayer.Visible    := TabControl1.TabIndex = 3;
  PanelFunctions.Visible:= TabControl1.TabIndex = 1;  }
  StringgridSmooth.visible := CheckBoxSmooth.Checked;
 { Start.Caption  := InttoStr(TrackBarStart.Position);
  Ende.Caption   := InttoStr(TrackBarEnd.Position);
  Resolution.caption  := format('Resolution: %d * %0:d', [1 shl (TrackBarEnd.Position + 1)]);   }
  Persistance.caption := format('Persistance:   %f', [TrackBarPersistance.Position / 100]);

  initializePalette;
  UpdateImagePal;
end;

procedure TMainForm.CheckBoxSmoothClick(Sender: TObject);
begin
//  TrackBarSmooth.Enabled := CheckBoxSmooth.Checked;
  StringgridSmooth.visible := CheckBoxSmooth.Checked;
end;

procedure TMainForm.TrackBarPersistanceChange(Sender: TObject);
begin
  Persistance.caption := format('Persistance:   %f', [TrackBarPersistance.Position / 100]);
end;

procedure TMainForm.Button3Click(Sender: TObject);
begin

  If savePictureDialog1.Execute then
  Begin
    If SavePictureDialog1.Filename <> '' then
    Begin
      If extractFileExt(SavePictureDialog1.Filename) <> '.bmp' then
        SavePictureDialog1.Filename := SavePictureDialog1.Filename + '.bmp';
      Image1.Picture.Bitmap.SaveToFile(SavePictureDialog1.Filename);
    End;
  End;
end;

Function TMainForm.GetFunctions(var PerlinFunc : Array of TPerlFunc) : Integer;
var
  i, n, o  : Integer;
  ComboBox : TCombobox;
  Edits    : Array[1..3] of TEdit;
Begin
  n := 0;
  For i := 1 to 6 do
  Begin
    ComboBox := FindComponent(Format('ComboBoxFunc%d', [i])) as TCombobox;

    For o := 1 to 3 do
    Begin
      Edits[o] := (FindComponent(Format('Edit%dArg%d', [i, o])) as TEdit);
      If Edits[o].Text = '' then
        Edits[o].Text := '1';
      PerlinFunc[n].Arguments[o - 1] := StrToFloat(Edits[o].Text);
    end;

    PerlinFunc[n].Formular := CodeList[n + 1];

    If ComboBox.Text= 'Exponentize' then
      PerlinFunc[n].Func := Fexponentize
    else
    If ComboBox.Text= 'Marble' then
      PerlinFunc[n].Func := FMarble
    else
    If ComboBox.Text= 'Wood' then
      PerlinFunc[n].Func := FWood
    else
    If ComboBox.Text= 'Resize' then
      PerlinFunc[n].Func := FResize
    else
    If ComboBox.Text= 'Smooth' then
      PerlinFunc[n].Func := FSmooth
    else
    If ComboBox.Text= 'Invert' then
      PerlinFunc[n].Func := FInvert
    else
    If ComboBox.Text= 'Advanced' then
      PerlinFunc[n].Func := FAdvanced
    else
      dec(n);

    inc(n);
  end;
  if n <= 0 then
  Begin
    PerlinFunc[n].Func := FNone;
    n := 1;
  end;
  Result := n;
End;

Procedure TMainForm.getBmps(var Bmps : Array of TBitmap; var Octaves : Array of Integer);
var
  i, n : Integer;
Begin
  n := 0;
  For i := 0 to 3 do
  Begin
    If LoadedLayers[i].Octave >= 0 then
    Begin
      Bmps[n] := TBitmap.create;
      Bmps[n].LoadFromFile(LoadedLayers[i].FileName);
      Octaves[n] := LoadedLayers[i].Octave;
      inc(n);
    end;
  end;
end;

procedure TMainForm.Button1Click(Sender: TObject);
Var
  Persistance   : Single;
  Start, Octaves: Byte;
  Seed          : Integer;
  ResizeMethod  : TResizeMethod;
  Smooth        : Boolean;
  weighten      : Array[0..24] of Single;
  translate     : Single;
  Scale         : Single;
  AddMode       : TAddMode;
  x, y, i, n    : Integer;
  PerlinFunc    : TPerlinFunc;
  FuncArgs      : Array of Single;
  PerlFuncs     : Array of TPerlFunc;
  LenPerlFunc   : Integer;
  Bmps          : Array of TBitmap;
  BmpOctaves    : Array of Integer;
begin
  n := 0;
  If CheckBoxLayer.Checked then
  Begin
    For i := 0 to 3 do
    Begin
      If LoadedLayers[i].Octave >= 0 then
        inc(n);
    end;
    Setlength(Bmps, n);
    Setlength(BmpOctaves, n);
    getBmps(Bmps, BmpOctaves);
  end
  else
  Begin
    Setlength(Bmps, 0);
    Setlength(BmpOctaves, 0);
  end;
  Persistance := trackBarPersistance.Position / 100;
  Start   :=     TrackBarStart.Position;
  Octaves := 1 + TrackBarEnd.Position - TrackBarStart.Position;
  Seed    := TrackBarSeed.Position;
  If ComboboxResize.Text = 'BiCubic' then
    ResizeMethod := RMCubic
  else
  If ComboboxResize.Text = 'BiCosinus' then
    ResizeMethod := RMCosinus
  else
  If ComboboxResize.Text = 'BiQuadratic' then
    ResizeMethod := RMQuadratic
  else
  If ComboboxResize.Text = 'BiLinear' then
    ResizeMethod := RMLinear;

  Smooth  := checkBoxSmooth.checked;
//  weighten := trackBarSmooth.Position / 10;
  For y := 0 to 4 do
    for x := 0 to 4 do
      weighten[y * 5 + x] := StrToFloat(StringGridSmooth.Cells[y, x]);
  If ComboBoxAdd.text = 'AddSigned' then
    AddMode := AMSigned
  else
  If ComboBoxAdd.text = 'AddUnsigned' then
    AddMode := AMUnSigned
  else
  If ComboBoxAdd.text = 'AddAbsolute' then
    AddMode := AMAbs
  else
  If ComboBoxAdd.text = 'AddNormalized' then
    AddMode := AMNormalized;

  setlength(PerlFuncs, 6);
  LenPerlFunc := GetFunctions(PerlFuncs);
  setlength(PerlFuncs, LenPerlFunc);


  If EditScale.Text = '' then
    EditScale.Text := '1';
  Scale := StrToFloat(EditScale.text);
  If EditTrans.Text = '' then
    EditTrans.Text := '0';
  translate := StrToFloat(Edittrans.text);
  queryperformancefrequency(freqq);
  queryPerformanceCounter(Startq);
  PerlinBmp := PerlinNoiseBmpE(Persistance , Start   , Octaves, Seed ,
                               Palette,
                               PerlFuncs   , Bmps, BmpOctaves, weighten,
                               Smooth, translate, Scale,
                               ResizeMethod, Addmode);
  queryPerformanceCounter(Stopq);
  time.caption := format('time: %f ms', [(stopq - startq) / freqq * 1000]);
 // PerlinBmp.PixelFormat := pf8Bit;
//  PerlinBmp.Palette := bmpPalette;
  Image1.Picture.Bitmap := PerlinBmp;
  PerlinBmp.Free;
end;

procedure TMainForm.TabControl1Change(Sender: TObject);
begin
  PanelBasic.Visible    := TabControl1.TabIndex = 0;
  PanelPalette.Visible  := TabControl1.TabIndex = 4;
  PanelSmooth.Visible   := TabControl1.TabIndex = 2;
  PanelLayer.Visible    := TabControl1.TabIndex = 3;
  PanelFunctions.Visible:= TabControl1.TabIndex = 1;
end;

procedure TMainForm.StringGridSmoothDblClick(Sender: TObject);
var
  input : String;
begin
  input := StringgridSmooth.Cells[StringgridSmooth.Selection.left,
                                  StringgridSmooth.Selection.top];
  input := inputbox('new Value', 'input new weighten for selected Pixel', input);
  If isnumeric(input) then
    StringgridSmooth.Cells[StringgridSmooth.Selection.left,
                           StringgridSmooth.Selection.top] := input;
end;

procedure TMainForm.StringGridSmoothKeyPress(Sender: TObject; var Key: Char);
begin
  If key = #13 then
    StringGridSmoothDblClick(Sender);
end;

procedure TMainForm.EditScaleChange(Sender: TObject);
begin
  If (EditScale.Text <> '') and not
     isnumeric(EditScale.Text) then
    editScale.Text := '1';
end;

procedure TMainForm.ComboBoxFuncChange(Sender: TObject);
var
  Number : String;
begin
  Number := (Sender as TComboBox).Name[Length((Sender as TComboBox).Name)];
  If (Sender as TComboBox).Text = 'Nothing' then
  Begin
    (FindComponent('Arg' + Number + '1') as TLabel).Caption := 'Arg1';
    (FindComponent('Arg' + Number + '2') as TLabel).Caption := 'Arg1';
    (FindComponent('Arg' + Number + '3') as TLabel).Caption := 'Arg1';
  End
  else
  If (Sender as TComboBox).Text = 'Exponentize' then
  Begin
    (FindComponent('Arg' + Number + '1') as TLabel).Caption := 'Cover';
    (FindComponent('Arg' + Number + '2') as TLabel).Caption := 'Sharpness';
    (FindComponent('Arg' + Number + '3') as TLabel).Caption := 'not Used';
  End
  else
  If (Sender as TComboBox).Text = 'Marble' then
  Begin
    (FindComponent('Arg' + Number + '1') as TLabel).Caption := 'MatrixF';
    (FindComponent('Arg' + Number + '2') as TLabel).Caption := 'XFactor';
    (FindComponent('Arg' + Number + '3') as TLabel).Caption := 'YFactor';
  End;
  If (Sender as TComboBox).Text = 'Wood' then
  Begin
    (FindComponent('Arg' + Number + '1') as TLabel).Caption := 'Factor';
    (FindComponent('Arg' + Number + '2') as TLabel).Caption := 'not Used';
    (FindComponent('Arg' + Number + '3') as TLabel).Caption := 'not Used';
  End;
  If (Sender as TComboBox).Text = 'Resize' then
  Begin
    (FindComponent('Arg' + Number + '1') as TLabel).Caption := 'New X';
    (FindComponent('Arg' + Number + '2') as TLabel).Caption := 'New Y';
    (FindComponent('Arg' + Number + '3') as TLabel).Caption := 'ResizeMode';
  End;
  If (Sender as TComboBox).Text = 'Smooth' then
  Begin
    (FindComponent('Arg' + Number + '1') as TLabel).Caption := 'innerF';
    (FindComponent('Arg' + Number + '2') as TLabel).Caption := 'middleF';
    (FindComponent('Arg' + Number + '3') as TLabel).Caption := 'outerF';
  End;
  If (Sender as TComboBox).Text = 'invert' then
  Begin
    (FindComponent('Arg' + Number + '1') as TLabel).Caption := 'not Used';
    (FindComponent('Arg' + Number + '2') as TLabel).Caption := 'not Used';
    (FindComponent('Arg' + Number + '3') as TLabel).Caption := 'not Used';
  End;
  If (Sender as TComboBox).Text = 'Advanced' then
  Begin
    (FindComponent('Arg' + Number + '1') as TLabel).Caption := 'not Used';
    (FindComponent('Arg' + Number + '2') as TLabel).Caption := 'not Used';
    (FindComponent('Arg' + Number + '3') as TLabel).Caption := 'not Used';
    Self.Enabled         := false;
    formulaform.Top      := Self.Top  + self.ClientHeight div 2;
    formulaform.Left     := Self.Left + self.ClientWidth  div 2;
    perlFormula.Number   := StrToInt(Number);
    formulaform.visible  := true;
    formulaform.MemoForm.Text := CodeList[StrToInt(Number)];
  end;

end;

procedure TMainForm.EditArgChange(Sender: TObject);
begin
  If ((Sender as TEdit).Text <> '') and not
     isnumeric((Sender as TEdit).Text) then
    (Sender as TEdit).Text := '1';
end;



{Function generatePalette(Palette : Array of TColor) : HPalette;
var
  pal : PLogPalette;
  i   : integer;
Begin
  Result := 0;
  getMem(pal, sizeOf(TLogPalette) + sizeOf(TPaletteEntry) * High(Palette));
  pal.palVersion    := $300;
  pal.palNumEntries := high(Palette);
  For i := 0 to high(Palette) do
  Begin
    pal.palPalEntry[i].peRed   := Palette[i] and $FF;
    pal.palPalEntry[i].peGreen := Palette[i] and $FF00;
    pal.palPalEntry[i].peBlue  := Palette[i] and $FF0000;
  end;
  Result := CreatePalette(pal^);
// Freemem(pal);
End;  }

procedure TMainForm.initializePalette;
var
  i : integer;
Begin
  For i := 0 to 255 do
    Palette[i] := rgb(i, i, i);
  {BmpPalette := GeneratePalette(Palette);
  image1.Picture.Bitmap.Palette := BmpPalette; }
End;

Procedure TMainForm.UpdateImagePal;
var
  x, y, i, n: Integer;
  Ba        : PByteArray;
Begin
  ImagePal.Canvas.Brush.Color := clBlack;
  ImagePal.Canvas.Rectangle(-1, -1, ImagePal.Width + 1, ImagePal.Height + 1);
  ImagePal.Picture.Bitmap.PixelFormat := pf32Bit;
  For y := 0 to 15 do
  Begin
    For i := 2 to 10 do
    Begin
      Ba := ImagePal.Picture.Bitmap.ScanLine[y * 11 + i];
      For x := 0 to 15 do
        For n := 2 to 10 do
          Move(Palette[y * 16 + x], Ba[(x * 11 + n) * 4], 4);
    End;
  End;
End;

procedure TMainForm.ImagePalClick(Sender: TObject);
var
  Mouse : TPoint;
begin
  Mouse := PalMouse;
  Mouse.X :=  Mouse.X div 11;
  Mouse.Y := (Mouse.Y div 11) * 16;
  ColorDialog1.Color := RGBtoBGR(Palette[Mouse.Y + Mouse.X]);
  ColorDialog1.Execute;
  Palette[Mouse.Y + Mouse.X] :=  RGBtoBGR(ColorToRGB(ColorDialog1.Color));
  UpdateImagePal;
end;

procedure TMainForm.ImagePalMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  PalMouse.X := X;
  PalMouse.Y := Y;
end;

procedure TMainForm.ButtonRPalClick(Sender: TObject);
begin
  initializePalette;
  UpdateImagePal;
end;

procedure TMainForm.ButtonSPalClick(Sender: TObject);
var
  fileS : TFileStream;
  str   : String;
  len   : Integer;
begin
  If SaveDialogPalette.Execute then
  Begin
    If SaveDialogPalette.FileName = '' then
      exit;
    If Fileexists(SaveDialogPalette.FileName) then
      If MessageBox(0, 'Really want to overwrite the file?', 'Are you sure?',
                     MB_ICONWARNING or MB_YesNo) = IDNO then
        exit;
    If extractFileext(SaveDialogPalette.FileName) <> 'pal' then
      SaveDialogPalette.FileName := SaveDialogPalette.FileName + '.pal';
    fileS := TFileStream.Create(SaveDialogPalette.FileName, fmCreate);
    fileS.Position := 0;
    Str := PalMagic;
    fileS.Write(Str[1], Length(Str));
    Len := Length(Palette);
    fileS.Write(Len, 4);
    files.Write(Palette[0], Length(Palette) * 4);
    files.Free;
  end;
end;

procedure TMainForm.ButtonLPalClick(Sender: TObject);
var
  fileS  : TFileStream;
  str, fn: String;
  len    : Integer;
  Col    : Array of MColor;
  i      : integer;
begin
  {For i := 0 to 255 do
    Palette[i] := (i * 2) mod 256;   }
  If OpenDialogPalette.Execute then
  Begin
    If not(Fileexists(OpenDialogPalette.FileName)) then
      exit;
    fileS := TFileStream.Create(OpenDialogPalette.FileName, fmOpenRead);
    fileS.Position := 0;
    Setlength(Str, 7);
    fileS.Read(Str[1], 7);
    If (str <> PalMagic) and (fileS.Size <> 768) then
      MessageBox(0, PChar(Format('%s is not a valid Pal-File', [OpenDialogPalette.FileName])),
                 'not a valid palFile', MB_ICONERROR or MB_OK);
    If (Str = PalMagic) then
    Begin
      fileS.Read(Len, 4);
      files.Read(Palette[0], Length(Palette) * 4);
    end
    else
    if fileS.Size = 768 then
    Begin
      Setlength(Col, 256);
      files.Position := 0;
      files.Read(Col[0], Length(Col) * 3);
      For i := 0 to 255 do
        Palette[i] := Col[i].r + (Col[i].g shl 8) + (Col[i].b shl 16);
      setlength(Col, 0);
    End
    else
      MessageBox(0, PChar(Format('%s is not a valid Pal-File', [OpenDialogPalette.FileName])),
                 'not a valid palFile', MB_ICONERROR or MB_OK);
    updateImagePal;
    files.Free;
  end;
end;

procedure TMainForm.LabelLayerClick(Sender: TObject);
begin
  If openDialogLayer.execute then
  Begin
    If (extractFileext(openDialogLayer.FileName) = '.bmp') and
       (fileexists(openDialogLayer.fileName)) then
    Begin
      LoadedLayers[StrToInt((Sender as TLabel).Name[11]) - 1].FileName := openDialogLayer.fileName;
      (Sender as TLabel).Caption := extractFileName(openDialogLayer.fileName);
    end;
  end;
end;

procedure TMainForm.ComboBoxLayerChange(Sender: TObject);
begin
  If lowerCase((Sender as TCombobox).Text) = 'none' then
  Begin
//    LoadedLayers[StrToInt((Sender as TCombobox).Name[14]) - 1].FileName := '';
    LoadedLayers[StrToInt((Sender as TCombobox).Name[14]) - 1].Octave    := -1;
    LoadedLayers[StrToInt((Sender as TCombobox).Name[14]) - 1].OrgOctave := -1;
    {(FindComponent(format('LabelLayer%s',
                       [(Sender as TCombobox).Name[14]])) as TLabel).Caption := '';  }
  End
  else
  Begin
    If LoadedLayers[StrToInt((Sender as TCombobox).Name[14]) - 1].FileName = '' then
    Begin
      openDialogLayer.execute;
      If not(extractFileext(openDialogLayer.FileName) = '.bmp') or
         not(fileexists(openDialogLayer.fileName)) then
        exit
      else
      Begin
        LoadedLayers[StrToInt((Sender as TCombobox).Name[14]) - 1].FileName :=
                      openDialogLayer.fileName;
        (FindComponent(format('LabelLayer%s',
                       [(Sender as TCombobox).Name[14]])) as TLabel).Caption :=
                       extractFileName(openDialogLayer.fileName);
      End;
    end;
    LoadedLayers[StrToInt((Sender as TCombobox).Name[14]) - 1].Octave    :=
                 StrToInt((Sender as TCombobox).Text);
    LoadedLayers[StrToInt((Sender as TCombobox).Name[14]) - 1].OrgOctave :=
                 StrToInt((Sender as TCombobox).Text);
  End;
end;

procedure TMainForm.CheckBoxLayerClick(Sender: TObject);
var
  i : integer;
begin
  For i := 1 to 4 do
    (FindComponent(format('ComboBoxLayer%d', [i])) as TComboBox).enabled := CheckBoxLayer.checked;

end;

procedure TMainForm.EditTransChange(Sender: TObject);
begin
  If (EditTrans.Text <> '') and not
     isnumeric(EditTrans.Text) then
    editTrans.Text := '1';
end;

end.
