unit numerics;

interface
type
  PSingleArray = ^TSingleArray;
  TSingleArray = Array of Single;
  PIntegerArray = ^TIntegerArray;
  TIntegerArray = Array of Integer;

  function StrToHex(StrParam : String) : Cardinal;
  function StrToInt(StrParam : String) : Cardinal;

  function isnumeric(StrParam : string)   : Boolean;
  function isinteger(StrParam : String)   : Boolean;

implementation

function isnumeric(StrParam : string) : Boolean;
const fnumbers  = ['0','1','2','3','4','5','6','7','8','9','-'];
const numbers   = ['0','1','2','3','4','5','6','7','8','9',','];
const inumbers  = ['0','1','2','3','4','5','6','7','8','9'];
Label Int;
var
  i, n : integer;
Begin
  Result := false;
  if (StrParam = '') or not(StrParam[1] in fnumbers)
  or (Length(StrParam) = 1) and (StrParam[1] = '-') then
    exit;

  for i := 2 to length(StrParam) do
    if not(StrParam[i] in numbers) then
      exit
    else
    If StrParam[i] = ',' then
      goto Int;
  Result := true;
  exit;
  Int:
  for n := i + 1 to length(StrParam) do
    if not(StrParam[n] in inumbers) then
      exit;
  Result := true;
end;

function isinteger(StrParam : string) : Boolean;
const fnumbers  = ['0','1','2','3','4','5','6','7','8','9','-'];
const inumbers  = ['0','1','2','3','4','5','6','7','8','9'];
Label Int;
var
  i, n : integer;
Begin
  Result := false;
  if (StrParam = '') or not(StrParam[1] in fnumbers)
  or (Length(StrParam) = 1) and (StrParam[1] = '-') then
    exit;

  for i := 2 to length(StrParam) do
    if not(StrParam[i] in inumbers) then
      exit;
  Result := true;
end;

function StrToHex(StrParam : String) : Cardinal;
const HexString = '0123456789ABCDEF';
var
  i : integer;
  n : integer;
Begin
  Result := 0;
  for i := Length(StrParam) downto 1 do
  Begin
    n := 0;
    while (n < 15) and (StrParam[i] <> HexString[n + 1]) do
      inc(n);
    Result := Result + (n shl (4 * (Length(StrParam) - i)));
  end;
end;

function StrToInt(StrParam : String) : Cardinal;
const IntString = '0123456789';
var
  i : integer;
  n : integer;
Begin
  Result := 0;
  for i := Length(StrParam) downto 1 do
  Begin
    n := 0;
    while (n < 10) and (StrParam[i] <> IntString[n + 1]) do
      inc(n);
    Result := Result + n * round(exp(i * ln(10)));
  end;
end;
end.
