unit perlFormula;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, unit1;

type
  TFormulaform = class(TForm)
    MemoForm: TMemo;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Formulaform: TFormulaform;
  Number      : Integer;
implementation

{$R *.dfm}

procedure TFormulaform.Button3Click(Sender: TObject);
begin
  Mainform.enabled     := true;
  Formulaform.Visible := false;
  CodeList[Number]     := formulaform.MemoForm.Text;
end;

procedure TFormulaform.Button1Click(Sender: TObject);
var
  FileStream : TFileStream;
  id         : Integer;
begin
  If not(SaveDialog.Execute) or (SaveDialog.FileName = '') then
    exit;

  If    not(extractFileext(SaveDialog.FileName) = extractFileext(SaveDialog.Filter)) then
    SaveDialog.FileName := SaveDialog.FileName  + extractFileext(SaveDialog.Filter);

  If FileExists(SaveDialog.FileName) then
  Begin
    id := MessageBox(0, 'Filename already exists. Overwrite?', 'File already exists',
                        MB_ICONWARNING or MB_YESNOCANCEL);
    If not(id = idyes) then
    Begin
      If id = idno then
        Button1Click(Sender);
      exit;
    end;
  end;

  FileStream := TFileStream.Create(SaveDialog.filename, fmcreate);
  FileStream.Write(MemoForm.text[1], Length(MemoForm.Text));
  FileStream.Free;
end;

procedure TFormulaform.Button2Click(Sender: TObject);
var
  FileStream : TFileStream;
  id         : Integer;
  MemText    : String;
begin
  If not(OpenDialog.Execute) or (OpenDialog.FileName = '') then
    exit;

  If not(FileExists(OpenDialog.FileName)) then
  Begin
    id := MessageBox(0, 'Filename not exists. Change?', 'File not exists',
                        MB_ICONWARNING or MB_YESNO);
    If id = idyes then
    Begin
      Button2Click(Sender);
      exit;
    end;
  end;

  FileStream := TFileStream.Create(OpenDialog.filename, fmopenRead);
  Setlength(MemText, FileStream.Size);
  FileStream.Read(MemText[1], Length(MemText));
  MemoForm.text := MemText;
  FileStream.Free;
end;

procedure TFormulaform.FormClose(    Sender: TObject;
                                  var Action: TCloseAction);
begin
  Mainform.enabled     := true;
  CodeList[Number]     := formulaform.MemoForm.Text;
end;

end.
